Option Explicit
  
Sub installationSuccessful(CONFIGURATION,DEMONSTRATION)

  Dim demoName, messageText

  demoName = DEMONSTRATION.DocumentElement.selectSingleNode("/demoConfiguration/Name").text

  messageText = demoName & " Successfully Installed." 
  messageText = messageText & Chr(13) & Chr(13) & "To start the Demo open the folder:"
  messageText = messageText & Chr(13) & Chr(13) & Chr(9) & "'" & CONFIGURATION.getShortCutFolderName() & "'"
  messageText = messageText & Chr(13) & Chr(13) & "This folder is located on your Desktop."
  
  MsgBox messageText,vbOKOnly + vbInformation

End Sub

Sub createFolders(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, folder, folderPath 
  
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/newFolderList/folders/folder")
    
  For i = 0 to nodeList.length - 1
     Set folder = nodeList.item(i)
     folderPath = CONFIGURATION.replaceMacros(folder.text)
     writeLogMessage "CreateFolder : '" + folderPath + "'"
     FILEMANAGER.createEmptyFolder(folderPath)
  Next 
  
End Sub

Sub copyFiles(CONFIGURATION,DEMONSTRATION,FILEMANAGER)
 
  Dim nodeList, i, sourceFile, targetFile
    
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/copyList/files/file")

  For i = 0 to nodeList.length - 1
     sourceFile = XMLHELPER.getTextNode(nodeList.item(i),"source")
     targetFile = XMLHELPER.getTextNode(nodeList.item(i),"target")
     writeLogMessage "Copy File : Source = '" + sourceFile + "'. Target = '" + targetFile + "'" 
     FILEMANAGER.copyFile CONFIGURATION, sourceFile, targetFile
  Next 
  
End Sub


Sub copyFolders(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, sourceFolder, targetFolder
  
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/copyList/folders/folder")

  For i = 0 to nodeList.length - 1
     sourceFolder      = XMLHELPER.getTextNode(nodeList.item(i),"source")
     targetFolder      = XMLHELPER.getTextNode(nodeList.item(i),"target")
     writeLogMessage "Copy Folder : Source = '" + sourceFolder + "'. Target = '" + targetFolder + "'"
     FILEMANAGER.copyFolder CONFIGURATION, sourceFolder, targetFolder
  Next 
  
End Sub

Sub cloneFiles(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, sourceFile, targetFile 
  
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/cloneList/files/file")

  For i = 0 to nodeList.length - 1
     sourceFile = XMLHELPER.getTextNode(nodeList.item(i),"source")
     targetFile = XMLHELPER.getTextNode(nodeList.item(i),"target")
     writeLogMessage "Clone File : Source = '" + sourceFile + "'. Target = '" + targetFile + "'"
     FILEMANAGER.cloneFile CONFIGURATION, sourceFile, targetFile
  Next 
  
End Sub

Sub cloneFolders(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, sourceFolder, targetFolder
  
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/cloneList/folders/folder")

  For i = 0 to nodeList.length - 1
     sourceFolder = XMLHELPER.getTextNode(nodeList.item(i),"source")
     targetFolder = XMLHELPER.getTextNode(nodeList.item(i),"target")
     writeLogMessage "Clone Folder : Source = '" + sourceFolder + "'. Target = '" + targetFolder + "'"
     FILEMANAGER.cloneFolder CONFIGURATION, sourceFolder, targetFolder
  Next 
  
End Sub

Sub doInstallActions(CONFIGURATION,DEMONSTRATION,SQLPLUS,HTTP)

  Dim nodeList, i, action, actionType, user, password, sqlScript, mode, local, remote

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/installation/action")
  For i = 0 to nodeList.length - 1
    Set action = nodeList.item(i)
    actionType = action.getAttribute("type")
    user       = CONFIGURATION.replaceMacros(action.getAttribute("user"))
    password   = CONFIGURATION.replaceMacros(action.getAttribute("password"))

    If actionType = "SQL" Then
        sqlScript = CONFIGURATION.replaceMacros(action.text)
        writeLogMessage "SQL : Script = '" + sqlScript + "'."
    	If user = "SYS" Then
    	  SQLPLUS.executeSYSDBA sqlScript
    	Else
    	  SQLPLUS.executeSQLPLUS user,password,sqlScript
    	End If
    End If

    If actionType = "PUT" Then
      mode   = XMLHELPER.getDefaultTextNode(action,"mode","SKIP")
      local  = XMLHELPER.getTextNode(action,"local")
      remote = XMLHELPER.getTextNode(action,"remote")
      writeLogMessage "PUT : Resource = '" + local + "'."
      HTTP.uploadFile local, remote, mode, user, password
    End If

    If actionType = "MKCOL" Then
      mode   = XMLHELPER.getTextNode(action,"mode") = "FORCE"
      remote = XMLHELPER.getTextNode(action,"remote")
      writeLogMessage "MKCOL : Resource = '" + remote + "'."
      HTTP.makeDir remote, mode, user, password
    End If

    If actionType = "DELETE" Then
      mode   = XMLHELPER.getTextNode(action,"mode") = "FORCE"
      remote = XMLHELPER.getTextNode(action,"remote")
      writeLogMessage "DELETE : Resource = '" + remote + "'."
      HTTP.doDelete remote, user, password
    End If
  Next 
  
End Sub

Sub makeWebFolders(DEMONSTRATION, HTTP)

  ' Added NLS Support - Web Folders Targets must exist,

  Dim nodeList, i, URL, shortCutName, shortCutFolderPath, expandedURL 
  
  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/WebDAV/shortCuts/shortCut")

  For i = 0 to nodeList.length - 1
     URL = XMLHELPER.getTextNode(nodeList.item(i),"URL")
     shortCutName = XMLHELPER.getTextNode(nodeList.item(i),"Name")
     shortCutFolderPath = XMLHELPER.getTextNode(nodeList.item(i),"Location")
     HTTP.makeWebFolderUser shortCutName, URL, shortCutFolderPath
  Next 

  ' SQLPlus.ExecuteSYSDBA "SQL/deleteWebFolders" & " " & installParameters.getUser()
  
End Sub

Sub makeSqlShortCuts(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i , shortCutName, location, target, arguments, icon 

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/SQL/shortCuts/shortCut")

  For i = 0 to nodeList.length - 1
     shortCutName = XMLHELPER.getTextNode(nodeList.item(i),"Name")
     location     = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Location")
     target       = CONFIGURATION.getSqlPlusPath()
     arguments    = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Connection") & " " & _
                    XMLHELPER.getOptionalTextNode(nodeList.item(i),"Script") & " " & _
                    XMLHELPER.getOptionalTextNode(nodeList.item(i),"Arguments")                                      
     icon         = XMLHELPER.getDefaultTextNode(nodeList.item(i),"icon","%DEMODIRECTORY%\Install\SQLPLUS.ICO")
     FILEMANAGER.makeShortCut CONFIGURATION, null, shortCutName, target, icon, null, arguments
  Next 
  
End Sub

Sub makeHttpShortCuts(DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, shortCutName, shortCutFolderPath, target, arguments, icon

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/HTTP/shortCuts/shortCut")

  For i = 0 to nodeList.length - 1
     shortCutName       = XMLHELPER.getTextNode(nodeList.item(i),"Name")
     shortCutFolderPath = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Location")
     target             = XMLHELPER.getTextNode(nodeList.item(i),"localPath")
     arguments          = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Arguments")
     icon               = XMLHELPER.getOptionalTextNode(nodeList.item(i),"icon")
     FILEMANAGER.makeHttpShortCut shortCutFolderPath, shortCutName, target, icon, arguments
  Next 
  
End Sub


Sub makeFtpScripts(CONFIGURATION,DEMONSTRATION,FILEMANAGER)
  
  Dim scriptFilename, scriptFile, targetDirectory, ftpCommand,ftpFile
  
  Dim nodeList, i, commandNodeList, c

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/FTP/scripts/script")

  For i = 0 to nodeList.length - 1

     scriptFileName  = XMLHELPER.getTextNode(nodeList.item(i),"Name")
     scriptFile      = CONFIGURATION.getScriptsFolderPath() + "\" + scriptFileName + ".ftp"
     targetDirectory = XMLHELPER.getTextNode(nodeList.item(i),"remotePath")

     Set ftpFile = FILEMANAGER.CreateTextFile(scriptFile)
     createFtpScript ftpFile, CONFIGURATION.getHostname(), CONFIGURATION.getFtpPort(), _
                     CONFIGURATION.getUsername(), CONFIGURATION.getPassword(), targetDirectory

     Set commandNodeList = nodeList(i).getElementsByTagName("command")
                        
     For c = 0 to commandNodeList.length - 1
       ftpCommand = commandNodeList.item(c).text
       ftpFile.writeline(ftpCommand)
     Next 
     ftpFile.writeline("")
     ftpFile.close
  Next 
  
End Sub

Sub createFTPScript(ftpFile, hostname, port, user, password, remoteDirectory)

  ftpFile.writeline("open " & hostname & " " & port)
  ftpFile.writeline("user " & user & " " & password)
  ftpFile.writeline("cd " & remoteDirectory)

End Sub

Sub makeGeneralShortCuts(CONFIGURATION,DEMONSTRATION, FILEMANAGER)

  Dim nodeList, i, shortCutName, shortCutFolderPath, target, directory, icon, arguments

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/General/shortCuts/shortCut")

  For i = 0 to nodeList.length - 1
    shortCutName       = XMLHELPER.getTextNode(nodeList.item(i),"Name")
    shortCutFolderPath = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Location")
    target             = XMLHELPER.getOptionalTextNode(nodeList.item(i),"path")
    directory          = XMLHELPER.getOptionalTextNode(nodeList.item(i),"directory")
    icon               = XMLHELPER.getOptionalTextNode(nodeList.item(i),"icon")
    arguments          = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Arguments")
    FILEMANAGER.makeShortCut CONFIGURATION, shortCutFolderPath, shortCutName, target, icon, directory, arguments
  Next 
  
End Sub
 
Sub makeFavorites(CONFIGURATION,DEMONSTRATION,FILEMANAGER)

  Dim nodeList, i, linkFolderName, linkFolderPath, shortCutName, shortCutFolderPath, target, arguments, icon

  Set nodeList = DEMONSTRATION.documentElement.selectNodes("/demoConfiguration/Favorites/shortCuts/shortCut")

  If (nodeList.length > 0) Then
    linkFolderName = DEMONSTRATION.documentElement.selectSingleNode("/demoConfiguration/Favorites/folder").text
    If linkFolderName = "" Then
      linkFolderName = "Oracle XML DB Demonstration"
    End If
    linkFolderPath = FILEMANAGER.makeFavoritesFolder(linkFolderName)
    
    For i = 0 to nodeList.length - 1
      shortCutName       = XMLHELPER.getTextNode(nodeList.item(i),"Name")
      target             = CONFIGURATION.getServerURL() & XMLHELPER.getTextNode(nodeList.item(i),"localPath")
      shortCutFolderPath = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Location")
      arguments          = XMLHELPER.getOptionalTextNode(nodeList.item(i),"Arguments")
      icon               = XMLHELPER.getOptionalTextNode(nodeList.item(i),"icon")
      FILEMANAGER.makeHttpShortCut shortCutFolderPath, shortCutName,  target, icon, arguments
    Next 
  End If
  
End Sub

Class fileSystemControl

  Private windowsShell
  Private fileSystem

  Public Sub Initialize (WSHELL, WINFS)
    Set windowsShell = WSHELL
    Set fileSystem   = WINFS
  End Sub

  Public Sub deleteExistingFolder(folderPath)
     
    Dim folder
 
     If fileSystem.folderExists(folderPath) Then
        Set folder = fileSystem.getFolder(folderPath)
        deleteFolder(folder)
     End If

  End Sub

  Private Sub deleteFolder(folder)
   
    Dim subFolders, Files, subFolder, file, button

    Set subFolders = folder.SubFolders
    For each subFolder in subFolders
      deleteFolder(subFolder)
    Next
        
    Set files = folder.files
    For each file in files
      file.attributes = 0
      On Error Resume Next
      fileSystem.deleteFile(file.path)
      If Err.number  <> 0 Then
        button = MsgBox ("Fatal Error deleting File : " & file.path & ". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical)
        self.close()    	
      End If
      On Error GoTo 0  
    Next

    folder.attributes = 0
 
    On Error Resume Next
    fileSystem.deleteFolder(folder.path)
    If Err.number  <> 0 Then
      button = MsgBox ("Fatal Error deleting Folder : " & folder.path & ". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical)
      self.close()    	
    End If
    On Error GoTo 0  
        
  End sub

  Public Sub createEmptyFolder(folderPath)

    Dim emptyFolder

    deleteExistingFolder(folderPath)
    Set emptyFolder = CreateFolder(folderPath)

  End Sub   
  
  Public Function createFolder(sourceFolderName)
    Dim button
    On Error Resume Next
    Set CreateFolder = fileSystem.createFolder(sourceFolderName)
    If Err.number  <> 0 Then
      button = MsgBox ("createFolder(" & sourceFolderName & ") - Fatal Error encountered creatng folder. Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
      self.close()    	
    End If
  End Function

  Public Sub cloneFolder(installParameters, sourceFolderName,targetFolderName)
   
    Dim sourceFolder, targetFolder, button
  
    On Error Resume Next
    Set sourceFolder = fileSystem.getFolder(sourceFolderName)
    If Err.number  <> 0 Then
      button = MsgBox ("cloneFolder(" & sourceFolderName & ") - Fatal Error encountered creatng folder. Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
      self.close()    	
    End If
    Set targetFolder = fileSystem.getFolder(targetFolderName)
    cloneSubFolder installParameters, sourceFolder, targetFolder
  End Sub

  Public Sub CopyFile(installParameters, sourceFile,targetFile)
    fileSystem.copyFile sourceFile,targetFile
  End Sub 

  Public Sub copyFolder(installParameters, sourceFolderName,targetFolderName)
    fileSystem.copyFolder sourceFolderName, targetFolderName
  End Sub

  Private Sub cloneSubFolder(installParameters, sourcefolder, targetFolder)

    Dim subFolders, subFolder, Files, file, targetFilename, newFolder

    Set SubFolders = sourcefolder.SubFolders
    For each SubFolder in SubFolders
      Set newFolder = fileSystem.createFolder(targetFolder.path & FILE_SEPERATOR & Subfolder.name)       
      cloneSubFolder installParameters, SubFolder, newFolder
    Next
        
    Set files = sourcefolder.files
    for each file in files
      targetFilename = targetFolder.path & FILE_SEPERATOR & file.name
      cloneFile installParameters, file.path, targetFilename
    Next

  End Sub

  Public Sub CloneFile(installParameters, sourceFile,targetFile)

    Dim inFile, content, outFile

    Set InFile = fileSystem.openTextFile(sourceFile)
    content = inFile.readall
    inFile.close

    content = installParameters.replaceMacros(content)
  
    Set outFile = fileSystem.createTextFile(targetFile)
    outfile.writeline content
    outFile.close
  
  End Sub 

  Public Function createTextFile(filename)
     Set createTextFile = fileSystem.createTextFile(filename, True)
  End Function

  Public Function openTextFile(filename)
     Set openTextFile = fileSystem.openTextFile(filename, 8)
  End Function

  Sub makeShortcut(installParameters, shortCutFolderPath, shortcutName, targetPath, iconPath, targetDirectory, arguments)

    Dim oShellLink

    If IsNull(shortcutFolderPath) Then
      shortCutFolderPath = installParameters.getShortcutFolderPath()
    End If

    if IsNull(targetDirectory) Then
      targetDirectory = installParameters.getBaseFolderPath()
    End if

    Set oShellLink = windowsShell.CreateShortcut(shortCutFolderPath & FILE_SEPERATOR & shortcutName & ".lnk")

    oShellLink.WorkingDirectory = targetDirectory
    oShellLink.Description = ""
    oShellLink.WindowStyle = 1

    if not isNULL(targetPath) then
      oShellLink.targetPath = targetPath
    End if

    if not isNULL(iconPath) then
      oShellLink.IconLocation = iconPath
    End if
  
    if not isNULL(arguments) then
      oShellLink.Arguments = arguments
    End if

    oShellLink.Save

  End Sub
     
  Sub makeHttpShortcut(shortCutFolderPath, shortcutName, target, iconPath, arguments)

     Dim oShellLink
  
     If IsNull(shortcutFolderPath) Then
       shortCutFolderPath = CONFIGURATION.getShortcutFolderPath()
     End If

     If IsNull(iconPath) Then
       iconPath = "%SystemRoot%\system32\SHELL32.dll,13"
     End If

     Set oShellLink = windowsShell.CreateShortcut( shortCutFolderPath & FILE_SEPERATOR & shortCutName & ".lnk")
     oShellLink.IconLocation = iconPath
  
     If (arguments <> "") Then
     	target = target & "?" & arguments
     End If

     oShellLink.targetPath = target
     oShellLink.Save

  End Sub

  Public Function makeFavoritesFolder(folderName)

    Dim favorites, linkFolderPath, linkFolder

    favorites = windowsShell.SpecialFolders("Favorites")
    linkFolderPath = favorites & FILE_SEPERATOR & folderName
    
    createEmptyFolder(linkFolderPath)
    makeFavoritesFolder = linkFolderPath

  End Function
         
End Class


Class httpControl

  Private HttpObject
  Private windowsShell
  Private CONFIGURATION
  
  Public Sub initialize(CONFIG, WSHELL)
    Set CONFIGURATION = CONFIG
    Set windowsShell = WSHELL
  End Sub
  

  Dim     folderStatusList 
    
  Private Sub Class_Initialize()
  
   Set HttpObject = CreateObject("Msxml2.XMLHTTP.6.0")
   folderStatusList = Empty
   
  End Sub   
  
  Public Function uploadFile (local, remote, mode, user, password)
    
    Dim returnCode, rc, button

    returnCode = doHead(remote, user, password)
    
    If returnCode = 401 Then
      button = MsgBox ("uploadFile() - Unauthorized (Status (" & status & "). Unable to upload '" & local & "' into '" & remote & "'.  Please check installParameters.xml and log files.",vbOKOnly + vbCritical)
      self.close()    	
    End If

    If returnCode = 200 Then

      If mode = "ERROR" Then
        button = MsgBox("uploadFile() - Installation Failed. Resource Exists : '" & remote & "'. Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
        self.close()
      End If
      
      If mode = "SKIP" Then
        uploadFile = returnCode
        Exit Function
      End If
      
      If mode = "FORCE" Then
        rc = doDelete(remote, user, password)
      End If
   
    End If

    uploadFile = doPut (local, remote, null, user, password)
    
    If uploadFile = 500 Then

      button = MsgBox("UploadFile() - Upload Failed (Status (" & uploadFile & "). Unable to upload '" & local & "' into '" & remote & "'.  Retry in Progress.",vbOKOnly + vbCritical)
      writeLogMessage "UploadFile() - Upload Failed (Status (" & uploadFile & "). Unable to upload '" & local & "' into '" & remote & "'.  Retry in Progress."
      uploadFile = doPut (local, remote, null, user, password)
      If uploadFile = 500 Then
        button = MsgBox("UploadFile() -  Installation Failed (Status (" & uploadFile & "). Unable to upload '" & local & "' into '" & remote & "'.  Please check installParameters.xml and log files.",vbOKOnly + vbCritical)
        self.close()    	
      End If
    End If

    If uploadFile = 401 Then
      button = MsgBox("UploadFile() - Unauthorized (Status (" & uploadFile & "). Unable to upload '" & local & "' into '" & remote & "'.  Please check installParameters.xml and log files.",vbOKOnly + vbCritical)
      self.close()    	
    End If
        
  End Function
  
  Public Sub makeWebFolderUser(shortCutName, targetURL, shortCutFolderPath)
    makeWebFolder shortCutName, targetURL, shortCutFolderPath, CONFIGURATION.getUsername(), CONFIGURATION.getPassword()
  End Sub

  Public Sub makeWebFolder(shortCutName, targetURL, shortCutFolderPath,user,password)

    Dim commandLine, returnCode, button
    
    Set folderStatusList = CreateObject("Scripting.Dictionary")
    
    returnCode = MakeDir(targetURL,true,user,password)
    
    If returnCode = 201 or returnCode = 200 Then

      ' WebFolderLink.exe /TARGET "http://localhost:8080/" /LINK "C:\TEMP\test"
      
      targetURL = makeWebFolderLinkURL(user,password) + targetURL
      commandLine = """" + CONFIGURATION.getInstallFolderPath() + FILE_SEPERATOR + "WebFolderLink.exe"" /TARGET """ + targetURL + """ /LINK """ + shortCutFolderPath + FILE_SEPERATOR + ShortCutName + """"    
      returnCode = windowsShell.run (commandLine,7,true)
    Else
      button = MsgBox("Installation Failed. Unable to access Web Folder '" & targetURL & "'. Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
      self.close()
    End If
    
    FolderStatusList = Empty
      
  End Sub

  Private Function makeWebFolderLinkURL(user,password)
    makeWebFolderLinkURL = "http://" & user & ":" & password & "@" & CONFIGURATION.getHostname() & ":" & CONFIGURATION.getHttpPort()
    ' makeWebFolderLinkURL = "http://" & user & ":" & password & "@" & CONFIGURATION.getHostname() & ":" & CONFIGURATION.getHttpPort()
  End Function

  
  Public Function makeDir(targetFolder,force,user,password)

    Dim Status, ParentFolder,button

    status = doHEAD(targetFolder, user, password)
    If not IsEmpty(folderStatusList) Then
      folderStatusList.add targetFolder, status
    End If
    If status = 404 and force Then
      parentFolder = Mid(targetFolder,1,InStrRev(targetFolder,"/")-1)
      makeDir parentFolder,true, user, password
      status = doMKCOL(targetFolder, user, password)
    End If
 
    makeDir = status    

    If status = 401 Then
      button = MsgBox ("doMKCOL() - Unauthorized (Status (" & status & "). Unable to create '" & targetFolder & "'.  Please check installParameters.xml and log files.",vbOKOnly + vbCritical)
      self.close()    	
    End If
        
  End Function

  Public Function doHEAD(remote,user,password)
  
    Dim button
    
    HttpObject.Open "HEAD", CONFIGURATION.getServerURL() & remote, false, user, password
    HttpObject.setRequestHeader "Content-type", "text/xml"
    HttpObject.setRequestHeader "Depth", "1"

    On Error Resume Next
    HttpObject.send ("")
    If Err.number  <> 0 Then
      button = MsgBox("doHEAD() - Fatal Error encountered accessing : " & CONFIGURATION.getServerURL() & remote & ". Status (" & Err.number  & ") " & Err.Description & ". Please check installParameters.xml and restart installation",vbOKonly + vbCritical)
      self.close()    	
    End If
    On Error GoTo 0  

    doHead = HttpObject.status

  End Function
  
  Public Function doPUT(local,remote,contentType,user,password)
  
   Dim ado_stream, button

   Set ado_stream = CreateObject("ADODB.Stream")
   ado_stream.Type = 1
   ado_stream.Open()

   On Error Resume Next
   ado_stream.LoadFromFile(local)
   If Err.number  <> 0 Then
     button = MsgBox ("doPUT() - Fatal Error encountered reading File : " & local & ". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical & ". Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
     self.close()    	
   End If
   On Error GoTo 0  
    
   HttpObject.Open "PUT", CONFIGURATION.getServerURL() & remote, false, user, password

   If not IsNull(contentType) Then
     HttpObject.setRequestHeader "Content-type", contentType
   End If
   
   On Error Resume Next
   HTTPObject.send(ado_stream.Read(-1))
   If Err.number  <> 0 Then
     button = MsgBox ("doPUT() - Fatal Error encountered sending File : " & local & " to " & CONFIGURATION.getServerURL() & remote &". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical & ". Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
     self.close()    	
   End If
   On Error GoTo 0  

   ado_stream.Close()

   doPUT = HttpObject.status
   If HTTPObject.status <> 201 Then
    writeLogMessage "doPUT (" & CONFIGURATION.getServerURL() & remote & ") : Status=" & HTTPObject.status 
   End If
 End Function

  Public Function doMKCOL(remote,user,password)
   
   Dim button
   
   ' writeLogMessage "doMKCOL (" & CONFIGURATION.getServerURL() & remote & ")"

   HttpObject.Open "MKCOL", CONFIGURATION.getServerURL() & remote, false, user, password
   HttpObject.setRequestHeader "Content-type", "text/xml"

   On Error Resume Next
   HttpObject.send("")
   If Err.number  <> 0 Then
     button = MsgBox("doMKCOL() - Fatal Error encountered making Folder : " & CONFIGURATION.getServerURL() & remote &". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical & ". Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
     self.close()    	
   End If
   On Error GoTo 0  

   doMKCOL = HTTPObject.status
   If HTTPObject.status <> 201 Then
     writeLogMessage "doMKCOL (" & CONFIGURATION.getServerURL() & remote & ") : Status=" & HTTPObject.status 
   End If

  End Function
    
  Public Function doDELETE(remote,user,password)
  
   Dim button
   
   HttpObject.Open "DELETE", CONFIGURATION.getServerURL() & remote, false, user, password
   HttpObject.setRequestHeader "Content-type", "text/xml"

   On Error Resume Next
   HttpObject.send("")
   If Err.number  <> 0 Then
     button = MsgBox ("doMKCOL() - Fatal Error deleting : " & CONFIGURATION.getServerURL() & remote &". Status (" & Err.number  & ") " & Err.Description,vbOKOnly + vbCritical & ". Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
     self.close()    	
   End If
   On Error GoTo 0  

   doDELETE = HTTPObject.status
   If HTTPObject.status <> 201  and HTTPObject.status <> 204 and HTTPObject.status <> 207 and HTTPObject.status <> 404 Then
    writeLogMessage "doDELETE (" & CONFIGURATION.getServerURL() & remote & ") : Status=" & HTTPObject.status 
   End If
  End Function

End Class

Class sqlPlusControl
    
  ' Test connection to the database
  
  Private CONFIGUARTION
  
  Public Sub initialize(CONFIG)
    Set CONFIGURATION = CONFIG
  End Sub

  Public Function testConnection(user, password, role)
    testConnection = execSQLPLUS(user, password, role, "sql/VerifyConnection.sql")
  End Function

  ' Execute SQL Script as demo user
  
  Public Function executeUser(sqlScript)
    executeUser = executeSQLPLUS(CONFIGURATION.getUserName(), CONFIGURATION.getPassword(), sqlScript)
  End Function

  ' Execute SQL Script as DBA user
  
  Public Function executeDBA(sqlScript)
    executeDBA = executeSQLPLUS(CONFIGURATION.getDBAUsername(), CONFIGURATION.getDBAPassword(), sqlScript)
  End Function
  
  ' Execute SQL Script as specified user

  Public Function executeSQLPLUS(username, password, sqlScript)
    executeSQLPLUS = execSQLPLUS(username, password, "", sqlScript)
  End Function

  Public Function executeSYSDBA(sqlScript)
    executeSYSDBA = execSQLPLUS("SYS", CONFIGURATION.getSysPassword(), " as sysdba", sqlScript)
  End Function
      
  Private Function execSQLPLUS(user, password, role, sqlScript)
    
     Dim commandLine
  
     commandLine = CONFIGURATION.getSQLPlusPath() & " -L " & user & "/" & password & "@" & CONFIGURATION.getTNSAlias() & role & " @" & sqlScript
     execSQLPLUS = runCommand(commandLine)
     
  End Function

  Private Function runCommand(commandLine)
 
    Dim returnCode, button

    On Error Resume Next
    returnCode = wShell.Run (commandLine, 7, true)
    If Err.number  <> 0 Then
      button = MsgBox ("runCommand() - Fatal Error encountered loading program : " & commandLine & ". Please check installParameters.xml and restart installation",vbOKOnly + vbCritical)
      self.close()    	
    End If

    runCommand = returnCode

    ' Set oExec = WindowsShell.Exec(CommandString)
    ' Do While oExec.Status = 0
          ' writeLogMessage "Waiting 10 Seconds while SQLPLUS execution completes"
    '    WScript.Sleep 1000
    ' Loop
    ' writeLogMessage "SQLPLUS execution completed"

    ' sqlPlusOutput = oExec.StdOut.ReadAll
    ' writeLogMessage sqlplusOutput
   
  End Function
  
End Class


Class configurationControl
 
  Private windowsShell
  Private fileSystem
  Private macroList

  Private demoName
  Private baseFolderPath  

  Private schemaURL
  Private winWordPath
  Private excelPath
  
  Sub Initialize(WINSHELL, WINFS)


    Dim scriptFilename, scriptFile 

    Set windowsShell        = WINSHELL
    Set fileSystem          = WINFS

    scriptFileName          = Mid(document.location.href ,9)    
    Set scriptFile          = fileSystem.getFile(scriptFileName)
    demoName                = scriptFile.parentFolder.parentFolder.name
    baseFolderPath          = scriptFile.parentFolder.parentFolder.path

    setWinWordPath
    SetExcelPath

  End Sub
  
  Public Function getDemoName()
    getDemoName = demoName
  End Function

  Public Function getBaseFolderPath
    getBaseFolderPath = baseFolderPath  
  End Function

  Public Sub addMacros(DEMONSTRATION,INSTALLATION)

    Dim nodeList, i, parameter, parameterName, parameterValue
   
    Set macroList           = CreateObject("Scripting.Dictionary")

    Set nodeList = INSTALLATION.documentElement.selectNodes("/installationParameters/parameter")
    For i = 0 to nodeList.length - 1
     Set parameter = nodeList.item(i)
     parameterName  = parameter.getAttribute("name")
     parameterValue = parameter.getAttribute("value")
     addMacro parameterName, parameterValue
    Next 
     
    addMacro "%DEMODIRECTORY%",  getBaseFolderPath()

    addMacro "%WINWORD%",        getWinWordPath()
    addMacro "%EXCEL%",          getExcelPath()

    addMacro "%ORACLEHOME%",     getOracleHome()
    addMacro "%DBA%",            getDBAUsername()
    addMacro "%DBAPASSWORD%",    getDBAPassword()
    addMacro "%USER%",           getUsername()
    addMacro "%PASSWORD%",       getPassword()

    addMacro "%TNSALIAS%",       getTnsAlias()
    addMacro "%LISTENER%",       getListener()
 
    addMacro "%HOSTNAME%",       getHostname()
    addMacro "%HTTPPORT%",       getHttpPort()
    addMacro "%FTPPORT%",        getFtpPort()

    addMacro "%SERVERURL%",      getServerURL()
    addMacro "%HOMEFOLDERURL%",  getHomeFolderURL()
         
    addMacro "%SHORTCUTFOLDER%", getShortCutFolderPath()

    schemaURL = DEMONSTRATION.selectSingleNode("/demoConfiguration/schemaConfiguration/primaryURL").text
    schemaURL = replaceMacros(schemaURL)
    addMacro "%SCHEMAURL%", schemaURL

  End Sub

  Public Function getShortCutFolderPath()
  
    Dim desktopPath
    desktopPath = windowsShell.SpecialFolders("Desktop")
    getShortCutFolderPath = desktopPath & FILE_SEPERATOR & getShortCutFolderName()
 
  End Function

  Public Function getShortcutFolderName()
  
    Dim target
    set target = Document.getElementById("shortCutFolderName")
    getShortcutFolderName = target.value
    
  End Function

  Public Function getOracleHome()
  
    Dim target
    set target = Document.getElementById("oracleHome")
    getOracleHome = target.value
    
  End Function
  
  Public Function getTNSAlias()
  
    Dim target
    set target = Document.getElementById("tnsAlias")
    getTNSAlias = target.value
    
  End Function

  Public Function getDBAUsername()
  
    Dim target
    set target = Document.getElementById("dbaUsername")
    getDBAUsername = target.value
    
  End Function

  Public Function getDBAPassword()
  
    Dim target
    set target = Document.getElementById("dbaPassword")
    getDBAPassword = target.value
    
  End Function

  Public Function getUsername()
  
    Dim target
    set target = Document.getElementById("oracleUsername")
    getUsername = target.value
    
  End Function

  Public Function getPassword()
  
    Dim target
    set target = Document.getElementById("oraclePassword")
    getPassword = target.value
    
  End Function

  Public Function getSYSPassword()
  
    Dim target
    set target = Document.getElementById("sysPassword")
    getDBAPassword = target.value
    
  End Function

  Public Function getListener()
  
    Dim target
    set target = Document.getElementById("listener")
    getListener = target.value
    
  End Function

  Public Function getHostName()
  
    Dim target
    set target = Document.getElementById("hostName")
    getHostName = target.value
    
  End Function

  Public Function getHttpPort()
  
    Dim target
    set target = Document.getElementById("httpPort")
    getHttpPort = target.value
    
  End Function
  Public Function getFtpPort()
  
    Dim target
    set target = Document.getElementById("ftpPort")
    getFtpPort = target.value
    
  End Function

  Function getServerURL()

    Dim target1, target2
    set target1 = Document.getElementById("hostName")
    set target2 = Document.getElementById("httpPort")
    getServerURL = "http://" & target1.value & ":" & target2.value

  End Function
  
  Private Sub SetWinWordPath()
    
      Dim WordApp

      On Error Resume Next

      Set WordApp = createObject("Word.Application")
      
      If Err.Number = 0 Then
        winWordPath = WordApp.path & FILE_SEPERATOR & "WINWORD.EXE"
        WordApp.quit
      Else
        winWordPath = "c:\program files\msoffice\bin\WINWORD.EXE"
      End If

      If not IsNull(WordApp) Then
        WordApp.quit
      End If
 
  End Sub

  Private Function getWinWordPath()
    getWinWordPath = winWordPath
  End Function

  Private Sub SetExcelPath()

      Dim ExcelApp

      On Error Resume Next

      Set ExcelApp = createObject("Excel.Application")

      If Err.Number = 0 Then
        ExcelPath = ExcelApp.path & FILE_SEPERATOR & "EXCEL.EXE"
      else
      	ExcelPath = "c:\program files\msoffice\bin\EXCEL.EXE"
      End If

      If not IsNull(ExcelApp) Then
        ExcelApp.quit
      End If

  End Sub

  Private Function getExcelPath()
    getExcelPath = excelPath
  End Function
  
  Public Function getConnectString
     getConnectString = getUsername() & "/" & getPassword() & "@" & getTNSAlias()
  End Function

  Public Function getHomeFolderURL
    getHomeFolderURL = getServerURL() & "/home/" & getUsername()
  End Function
  
  Public Function getInstallFolderPath
    getInstallFolderPath = getBaseFolderPath()  & FILE_SEPERATOR & "Install"
  End Function
 
  Public Function getLocalFolderPath
    getLocalFolderPath = getBaseFolderPath()  & FILE_SEPERATOR & "Local"
  End Function
 
  Public Function getScriptsFolderPath
    getScriptsFolderPath = getLocalFolderPath()  & FILE_SEPERATOR & "Scripts"
  End Function
 
  Public Function getSqlPlusPath
    getSqlPlusPath = getOracleHome() & FILE_SEPERATOR & "bin" & FILE_SEPERATOR & "sqlplus.exe"
  End Function

  Public Function getSchemaURL
    getSchemaURL = schemaURL
  End Function

  Public Sub addMacro(key,value)
       macroList.add key, value
  End Sub
  
  Public Function replaceMacros(value)

       Dim keys, i, key
       keys = macroList.keys
       For i = 0 to (UBound(keys))
        key = keys(i) 
        If InStr(value,key) > -1 Then
          value = replace(value,key,macroList.Item(key))
        End If
      Next

      replaceMacros = value
  
  End Function 
     
  private function getOracleHomeFromRegistry

    ' This Logic no Longer Applicable for installation 10g Shiphome Production 3.

    ' OracleHomeId      = windowsShell.RegRead ("HKLM\SOFTWARE\ORACLE\ALL_HOMES\LAST_HOME")
    ' OracleHomePath    = windowsShell.RegRead ("HKLM\Software\Oracle\ALL_HOMES\ID" & OracleHomeID & "\path")

    ' OracleHomeSID     = windowsShell.RegRead ("HKLM\Software\Oracle\HOME" & OracleHomeID & "\Oracle_SID")
    ' Set OracleHomeDir = fileSystem.getFolder(OracleHomePath)
 
    ' getOracleHomeFromRegistry = OracleHomePath  

  End function

End Class

Class XMLHELPERControl
  
  Private CONFIGURATION
  
  Public Sub Initialize(CONFIG)
    Set CONFIGURATION = CONFIG
  End Sub
  
  Public Function getOptionalTextNode(ParentNode, childname)
     getOptionalTextNode = getDefaultTextNode(ParentNode, childname, null)
  End Function
  
  Public Function getDefaultTextNode(ParentNode,Childname,default)
   
    Dim nl
    
    Set nl = ParentNode.getElementsByTagName(Childname)
    If nl.length = 0 Then
      If IsNull(default) Then
      	getDefaultTextNode = default
      Else
        getDefaultTextNode = CONFIGURATION.replaceMacros(default)
      End If
    Else
      getDefaultTextNode = getTextNode(parentNode,childName)
    End If
  End Function

  Public Function getTextNode(ParentNode,Childname) 
    getTextNode = CONFIGURATION.replaceMacros(ParentNode.getElementsByTagName(Childname).item(0).text)
  End Function

End Class
