<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:output  method="html"></xsl:output>
	<xsl:template match="shortCutFolderName">
		<tr>
			<td>Demonstration Folder</td>
			<td colspan="5">
				<input size="64" name="shortCutFolderName" id="shortCutFolderName">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="oracleHome">
		<tr>
			<td>Oracle Home</td>
			<td colspan="3">
				<input size="64" name="oracleHome" id="oracleHome">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="dba">
		<tr>
			<td>DBA User</td>
			<td>
				<input name="dbaUsername" id="dbaUsername">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
			<td>Password</td>
			<td align="right">
				<input type="password" name="dbaPassword" id="dbaPassword"/>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="oracleUser">
		<tr>
			<td>Install as </td>
			<td>
				<input name="oracleUsername" id="oracleUsername">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
			<td>Password</td>
			<td align="right">
				<input type="password" name="oraclePassword" id="oraclePassword"/>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="tnsAlias">
		<tr>
			<td>TNSAlias</td>
			<td>
				<input name="tnsAlias" id="tnsAlias">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
			<td>Listener</td>
			<td align="right">
				<input name="listener" id="listener">
					<xsl:attribute name="value"><xsl:value-of select="../listener"/></xsl:attribute>
				</input>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="hostName">
		<tr>
			<td>Host name</td>
			<td>
				<input name="hostName" id="hostName">
					<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
				</input>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="httpPort">
		<tr>
			<td>HTTP Port </td>
			<td>
				<input name="httpPort" id="httpPort">
					<xsl:attribute name="value"><xsl:value-of select="../httpPort"/></xsl:attribute>
				</input>
			</td>
			<td>FTP port</td>
			<td align="right">
				<input name="ftpPort" id="ftpPort">
					<xsl:attribute name="value"><xsl:value-of select="../ftpPort"/></xsl:attribute>
				</input>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="listener"/>
	<xsl:template match="oraclePassword"/>
	<xsl:template match="ftpPort"/>
	<xsl:template match="installationParameters">
		<table style="background-color:#ECE9D8;">
			<tbody>
				<xsl:apply-templates/>
				<tr align="right">
					<td colspan="3"/>
					<td align="right">
					   <input type="button" value="Cancel" onclick="cancelInstall()"/>
					  <xsl:text>&#160;</xsl:text>
					    <input type="button" value="Install" onclick="doInstall()"/>
					</td>
				</tr>
				<tr>
				  <td colspan="4">
				    <textarea rows="5" cols="65" id="installationLog" name="installationLog" readonly="true" wrap="OFF">
				    </textarea>
				  </td>
				</tr>
			</tbody>
		</table>
	</xsl:template>
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
</xsl:stylesheet>
