set echo on
create or replace view PURCHASEORDER_MASTER_VIEW 
as
  select m.* 
    from PURCHASEORDER p,
         xmlTable
         (
            '$p/PurchaseOrder'
            passing p.OBJECT_VALUE as "p"
            columns 
            REFERENCE            path  'Reference/text()',
            REQUESTOR            path  'Requestor/text()',
            USERID               path  'User/text()',
            COSTCENTER           path  'CostCenter/text()',
            SHIP_TO_NAME         path  'ShippingInstructions/name/text()',
            SHIP_TO_ADDRESS      path  'ShippingInstructions/address/text()',
            SHIP_TO_PHONE        path  'ShippingInstructions/telephone/text()',
            INSTRUCTIONS         path  'SpecialInstructions/text()'
         ) m
/
describe PURCHASEORDER_MASTER_VIEW
--
pause
--
create or replace view PURCHASEORDER_LINEITEM_VIEW 
as
  select m.REFERENCE, l.*
    from PURCHASEORDER p,
         xmlTable
         (
            '$p/PurchaseOrder' 
            passing p.OBJECT_VALUE as "p"
            columns 
            REFERENCE           path  'Reference/text()',
            LINEITEMS   xmlType path  'LineItems/LineItem'
         ) m,
         xmlTable
         (
           '$l/LineItem'
           passing m.LINEITEMS as "l"
           columns
           ITEMNO         path '@ItemNumber', 
           DESCRIPTION    path 'Description', 
           PARTNO         path 'Part/@Id', 
           QUANTITY       path 'Part/@Quantity', 
           UNITPRICE      path 'Part/@UnitPrice'
         ) l
/
describe PURCHASEORDER_LINEITEM_VIEW
--
quit
