﻿set echo on
--
create or replace view DEPARTMENT_XML_JPN of xmltype
with object id
(
  substr(extractValue(sys_nc_rowinfo$,'/部門/部門ID'),1,30)
) 
as
select xmlElement
       (
         "部門",
         xmlAttributes( d.DEPARTMENT_ID as "部門ID"),
         xmlElement("部門名", d.DEPARTMENT_NAME),
         xmlElement
         (
           "住所",
           xmlForest
           (
              STREET_ADDRESS as "番地", CITY as "市町村", STATE_PROVINCE as "都道府県",
              POSTAL_CODE as "郵便番号",COUNTRY_NAME as "国名"
           )
         ),
         xmlElement
         (
           "社員リスト",
           (
             select xmlAgg
                    (
                      xmlElement
                      (
                        "社員",
                        xmlAttributes ( e.EMPLOYEE_ID as "社員番号" ),
                        xmlForest
                        (
                          e.FIRST_NAME as "名", e.LAST_NAME as "姓", e.EMAIL as "Emailアドレス",
                          e.PHONE_NUMBER as "電話番号", e.HIRE_DATE as "入社年月日", j.JOB_TITLE as "役職",
                          e.SALARY as "給料", m.FIRST_NAME || ' ' || m.LAST_NAME as "上司"                
                        ),
                        xmlElement ( "COMMISSION", e.COMMISSION_PCT )
                      )
                    )
               from HR.EMPLOYEES e, HR.EMPLOYEES m, HR.JOBS j
              where e.DEPARTMENT_ID = d.DEPARTMENT_ID
                and j.JOB_ID = e.JOB_ID
                and m.EMPLOYEE_ID = e.MANAGER_ID
           )
         )
       ) as XML
  from HR.DEPARTMENTS d, HR.COUNTRIES c, HR.LOCATIONS l
 where d.LOCATION_ID = l.LOCATION_ID
   and l.COUNTRY_ID  = c.COUNTRY_ID
/
quit