set feedback on
set linesize 132
set long 10240
set pages 0
set echo on
column USER format A32
column LINEITEMS format A40
--
-- DeleteXML followed by insertXMLBefore
--
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p") 
/  
update PURCHASEORDER
   set object_value = deleteXML
                      (
                        object_value,
                        'PurchaseOrder/LineItems/LineItem[@ItemNumber="2"]'
                      )
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
pause
--
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
update PURCHASEORDER
   set object_value = insertXMLBefore
                      (
                        object_value, 
                        '/PurchaseOrder/LineItems/LineItem[@ItemNumber="1"]', 
                        XMLType
                        (
                         '<LineItem ItemNumber="0">
                            <Description>Rififi</Description>
                            <Part Id="37429155622" UnitPrice="29.95" Quantity="2"/>
                          </LineItem>'
                        )
                      )
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
pause
--
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
update PURCHASEORDER
   set object_value = insertChildXML
                      (
                        object_value, 
                        '/PurchaseOrder/LineItems', 
                        'LineItem',
                        XMLType
                        (
                         '<LineItem ItemNumber="4">
                            <Description>Dreyer Box Set</Description>
                            <Part Id="37429158425" UnitPrice="79.95" Quantity="1"/>
                          </LineItem>'
                        )
                      )
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
pause
--
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/ 
update PURCHASEORDER
   set object_value = appendChildXML
                      (
                        object_value, 
                        '/PurchaseOrder/LineItems', 
                        XMLType
                        (
                         '<LineItem ItemNumber="5">
                            <Description>Hard Boiled</Description>
                            <Part Id="715515009041" UnitPrice="39.95" Quantity="3"/>
                          </LineItem>'
                        )
                      )
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/
select USER, LINEITEMS
  from PURCHASEORDER,
       xmltable
       (
         '$p/PurchaseOrder'
         passing object_value as "p"
         columns 
         USERID              path 'User' ,
         LINEITEMS  xmltype  path 'LineItems/LineItem'
       ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/  
pause
--
update PURCHASEORDER
   set object_value = updateXML
                      (
                        object_value,
                        '/PurchaseOrder/LineItems',
                        XMLType
                        (
                         '<LineItems>                      
                            <LineItem ItemNumber="1">
                              <Description>Samurai 2: Duel at Ichijoji Temple</Description>
                              <Part Id="37429125526" UnitPrice="29.95" Quantity="3"/>
                            </LineItem>
                            <LineItem ItemNumber="2">
                              <Description>The Red Shoes</Description>
                              <Part Id="37429128220" UnitPrice="39.95" Quantity="4"/>
                            </LineItem>
                            <LineItem ItemNumber="3">
                              <Description>A Night to Remember</Description>
                              <Part Id="715515009058" UnitPrice="39.95" Quantity="1"/>
                             </LineItem>
                          </LineItems>'
                        )
                      ) 
 where xmlExists('$p/PurchaseOrder[Reference="EABEL-20030409123336251PDT"]' passing object_value as "p" ) 
/
quit

