set linesize 132
set pagesize 50
column DESCRIPTION format A40
set echo on
set timing on
--
set autotrace on explain
--
select REFERENCE, LINENUMBER, PARTNO, DESCRIPTION
  from PURCHASEORDER,
       XMLTable
       (
         '/PurchaseOrder'
         passing object_value
         columns
         REFERENCE         path '@Reference',
         LINEITEMS xmltype path 'LineItems'
       ),
       XMLTable
       (
         '/LineItems/LineItem[ora:contains(Part/@Description,"$(Seven)") > 0 and Quantity = 2]'
         passing LINEITEMS
         columns
         LINENUMBER        path '@ItemNumber',
         PARTNO            path 'Part/text()',
         DESCRIPTION       path 'Part/@Description'
       )
/
--
quit
