set long     10240
set pagesize   100
set linesize   132
column REFERENCE format A28
column NODE format A54
set echo on
--
set autotrace on explain
--
create index iPURCHASEORDER_FULL_TEXT 
    on purchaseorder p (object_value)
       indextype is ctxsys.context
       parameters ( 'section group ctxsys.NULL_SECTION_GROUP' )
/
pause
--
select count(*) 
  from purchaseorder p, hr.employees e, hr.departments d
 where contains (object_value,'$Seven and $Night') > 0
   and xmlExists('$p/PurchaseOrder[User=$USER]' passing object_value as "p", e.EMAIL as "USER")
   and e.department_id = d.department_id
   and d.department_name = 'Shipping'
/
set autotrace off
--
select any_path 
  from resource_view, purchaseorder p, hr.employees e, hr.departments d
 where ref(p) = extractValue(res,'/Resource/XMLRef')
   and contains (object_value,'$Seven and $Night') > 0
   and xmlExists('$p/PurchaseOrder[User=$USER]' passing object_value as "p", e.EMAIL as "USER")
   and e.department_id = d.department_id
   and d.department_name = 'Shipping'
/
set autotrace on explain
--
select REFERENCE, NODE
  from purchaseorder p, hr.employees e, hr.departments d,
       xmltable
       (
	  '/PurchaseOrder'
          passing object_value
          columns
          REFERENCE    path '@Reference',
          NODE         xmltype path '//*[contains(text() | @*,"Seven") or contains(text() | @*,"Night")]'
       )
 where contains (object_value,'$Seven and $Night') > 0
   and xmlExists('$p/PurchaseOrder[User=$USER]' passing object_value as "p", e.EMAIL as "USER")
   and e.department_id = d.department_id
   and d.department_name = 'Shipping'
/
quit
