set echo on
begin
  dbms_xmlschema.CopyEvolve
  (
     xdb$string_list_t('%SCHEMAURL%'),
     XMLSequenceType(xdburitype('/home/%USER%/poSource/evolution/revisedPurchaseOrder.xsd').getXML()),
     XMLSequenceType(xdburitype('/home/%USER%/poSource/evolution/evolvePurchaseOrder.xsl').getXML())
  );     
end;                                                       
/
pause
--
create index iPurchaseOrderUser on PurchaseOrder
(extractValue(object_value,'/PurchaseOrder/User'))
/
create index iLineItemPartNumber on LINEITEM_TABLE 
(ITEMNUMBER, PART.SYS_XDBBODY$, NESTED_TABLE_ID)
/
create index iPartNumber on LINEITEM_TABLE
(PART.SYS_XDBBODY$, NESTED_TABLE_ID)
/
create or replace trigger VALIDATE_PURCHASEORDER
before insert on PURCHASEORDER
for each row
begin
   if (:new.object_value is not null) then
     :new.object_value.schemavalidate();
   end if;
end;
/
call dbms_stats.gather_schema_stats(USER)
/
quit