set pagesize    50
set linesize   132
set long     10240
column COMPLEX_TYPE format A32
column SQL_TYPE     format A32
set echo on
select any_path 
  from resource_view r
 where under_path(res,'/home/%USER%') = 1
   and XMLExists
       (
         'declare default element namespace "http://xmlns.oracle.com/xdb/XDBResource.xsd"; (: :)
         $r/Resource[ContentType="text/xml"  and ends-with(DisplayName,"xsl")]'
         passing RES as "r"
       ) 
/
pause
--
select any_path 
  from resource_view r
 where under_path(res,'/home/%USER%/purchaseOrders') = 1
   and XMLExists
       (
         'declare namespace r = "http://xmlns.oracle.com/xdb/XDBResource.xsd"; (: :)
          $r/r:Resource[starts-with(r:DisplayName,"SBELL")]/r:Contents/PurchaseOrder' 
          passing RES as "r"
       ) 
/
select path 
  from path_view, purchaseorder p
 where ref(p) = extractValue(res,'/Resource/XMLRef')
   and XMLExists('$p/PurchaseOrder/LineItems/LineItem[Part="715515009058"]' passing object_value as "p")
   and under_path(res,'/home/%USER%/purchaseOrders/2003/Mar') = 1
/
pause
--
select COMPLEX_TYPE, SQL_TYPE 
  from resource_view,
       xmlTable
       (
         xmlNamespaces
         (
           'http://www.w3.org/2001/XMLSchema' as "xsd",
           'http://xmlns.oracle.com/xdb' as "xdb",
           'http://xmlns.oracle.com/xdb/XDBResource.xsd' as "res"
         ),
         '/res:Resource/res:Contents/xsd:schema/xsd:complexType'
         passing RES
         columns
         COMPLEX_TYPE varchar2(64) path '@name',
         SQL_TYPE varchar2(64) path '@xdb:SQLType'
       )
 where equals_path(RES,'/home/%USER%/poSource/xsd/purchaseOrder.xsd') = 1
/
quit
