<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:n1="http://www.w3.org/2001/XMLSchema" xmlns:r="http://xmlns.oracle.com/xdb/XDBResource.xsd" xmlns:xfiles="http://xmlns.oracle.com/xfiles" xmlns:xr="http://xmlns.oracle.com/xfiles">
	<xsl:output version="1.0" encoding="utf-8" omit-xml-declaration="no" indent="no" media-type="text/html"/>
	<xsl:include href="/XFILES/xsl/XFilesCommon.xsl"/>
	<xsl:template name="Reference">
		<tr>
			<td width="35%">
				<span class="xd">
					<label>Reference</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td align="left" nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="@Reference"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="User">
		<tr>
			<td width="35%">
				<span class="xd">
					<label>User</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td align="left" nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="User"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="Requestor">
		<tr>
			<td width="35%">
				<span class="xd">
					<label>Requestor</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td align="left" nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="Requestor"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="CostCenter">
		<tr>
			<td width="35%">
				<span class="xd">
					<label>Cost Center</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td align="left" nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="CostCenter"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="SpecialInstructions">
		<tr>
			<td width="35%">
				<span class="xd">
					<label>Special Instructions</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td align="left" nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="SpecialInstructions"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="name">
		<tr>
			<td align="right" nowrap="nowrap" width="35%">
				<span class="xd">
					<label>Ship to Contact</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="name"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="fullAddress">
		<tr>
			<td align="right" nowrap="nowrap" width="35%">
				<span class="xd">
					<label>Address</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td width="65%">
				<span class="xe">
					<xsl:value-of select="fullAddress"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="telephone">
		<tr>
			<td align="right" nowrap="nowrap" width="35%">
				<span class="xd">
					<label>Telelphone</label>
				</span>
			</td>
			<td width="12">
				<xsl:call-template name="t">
					<xsl:with-param name="width" select="12"/>
				</xsl:call-template>
			</td>
			<td nowrap="nowrap" width="65%">
				<span class="xe">
					<xsl:value-of select="telephone"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="ShippingInstructions">
		<xsl:for-each select="ShippingInstructions">
			<xsl:call-template name="name"/>
			<xsl:call-template name="fullAddress"/>
			<xsl:call-template name="telephone"/>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="PurchaseOrder">
		<xsl:for-each select="PurchaseOrder">
			<table width="100%" summary="" border="0" cellspacing="0" cellpadding="0">
				<tbody>
					<tr>
						<td>
							<xsl:call-template name="t">
								<xsl:with-param name="width" select="1"/>
								<xsl:with-param name="height" select="5"/>
							</xsl:call-template>
						</td>
					</tr>
					<tr>
						<td width="100%" class="x14">
							<xsl:text>Review PurcahserOrder : </xsl:text>
							<xsl:value-of select="@Reference"/>
						</td>
					</tr>
					<tr>
						<td>
							<xsl:call-template name="t">
								<xsl:with-param name="width" select="1"/>
								<xsl:with-param name="height" select="5"/>
							</xsl:call-template>
						</td>
					</tr>
					<tr>
						<td>
							<table width="100%" summary="" border="0" cellspacing="0" cellpadding="0">
								<tbody>
									<tr>
										<td nowrap="true">
											<table cellpadding="0" cellspacing="0" border="0" summary="">
												<tbody>
													<tr>
														<td width="100%">
															<table width="50%" valign="top">
																<xsl:call-template name="Reference"/>
																<xsl:call-template name="Requestor"/>
																<xsl:call-template name="User"/>
																<xsl:call-template name="CostCenter"/>
																<xsl:call-template name="SpecialInstructions"/>
															</table>
														</td>
														<td>
															<table valign="top">
																<xsl:call-template name="ShippingInstructions"/>
															</table>
														</td>
														<td valign="top">
														</td>
													</tr>
												</tbody>
											</table>
										</td>
									</tr>
								</tbody>
							</table>
						</td>
					</tr>
					<tr>
						<td>
							<table class="xb" style="border-collapse:collapse" cellpadding="3" cellspacing="0" border="0" width="100%" summary="">
								<tbody>
									<tr>
										<th width="15%" title="ItemNumber" class="x1u" scope="col" nowrap="true">
											<span align="right" title="ItemNumber" class="x2j">Item Number&#160;</span>
										</th>
										<th width="15%" title="PartNumber" class="x1u" scope="col" nowrap="true">
											<span align="right" title="PartNumber" class="x2j">Part Number&#160;</span>
										</th>
										<th width="40%" title="Description" class="x1u" scope="col" nowrap="true">
											<span title="Description" class="x2j">Description&#160;</span>
										</th>
										<th width="10%" title="UnitCost" class="x1u" scope="col" nowrap="true">
											<span align="right" title="UnitCost" class="x2j">Unit Cost&#160;</span>
										</th>
										<th width="10%" title="Quantity" class="x1u" scope="col" nowrap="true">
											<span align="right" title="Quantity" class="x2j">Quantity&#160;</span>
										</th>
										<th width="10%" title="TotalCost" class="x1u" scope="col" nowrap="true">
											<span align="right" title="TotalCost" class="x2j">Total Cost&#160;</span>
										</th>
									</tr>
									<xsl:for-each select="LineItems/LineItem">
										<tr>
											<td align="right" class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99" nowrap="true">
												<xsl:value-of select="@ItemNumber"/>
											</td>
											<td align="right" class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99" nowrap="true">
												<!-- <xsl:value-of select='format-number(Part/text(),"000000000000")'/> -->
												<xsl:value-of select="Part/text()"/>
											</td>
											<td class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99" nowrap="true">
												<xsl:value-of select="Part/@Description"/>
											</td>
											<td align="right" class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99" nowrap="true">
												<xsl:value-of select="Part/@UnitCost"/>
											</td>
											<td align="right" class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99" nowrap="true">
												<xsl:value-of select="Quantity"/>
											</td>
											<td align="right" class="x26" style="border-bottom:1px solid #cccc99; border-left:1px solid #cccc99; border-right:1px solid #cccc99" nowrap="true">
												<!-- <xsl:value-of select='format-number(Part/@UnitCost * Quantity,"$###,##0.00")'/> -->
												<xsl:value-of select="Part/@UnitCost * Quantity"/>
											</td>
										</tr>
									</xsl:for-each>
								</tbody>
							</table>
						</td>
					</tr>
				</tbody>
			</table>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="/">
		<html dir="ltr" lang="en-US">
			<head>
				<link rel="stylesheet" charset="UTF-8" type="text/css" href="/XFILES/lib/css/xdb-en-ie-6.css"/>
				<meta content="text/html; charset=UTF-8" http-equiv="Content-Type"/>
				<title>
					<xsl:text>Oracle XML DB : View PurchaseOrder</xsl:text>
				</title>
			</head>
			<body class="xc">
				<xsl:call-template name="XFilesBrowserVersion"/>
				<xsl:call-template name="PurchaseOrder"/>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
